#include <avr/io.h>
#include <math.h>
#include <stdint.h>
#include "lcd-routines.h"
#include <util/delay.h>
#include "daten.h"

void ausgeben(void)
{
	char Buffer[20];
	dtostrf(T,2,2,Buffer);
	set_cursor(0,0);
	lcd_string(Buffer);
	lcd_string("C");
	lcd_secondLine();
	set_cursor(1,2);
	lcd_data('s');
}	
void adw(mux)
{
	int i=0;
	uint16_t result;

	ADCSRA=(1<<ADEN)|(1<<ADPS1)|(1<<ADPS0);
	ADMUX= mux;
	ADMUX|=(1<<REFS1)|(1<<REFS0);
	ADCSRA|=(1<<ADSC);
	while(ADCSRA & (1<<ADSC))
	{}
	result=ADCW;
	
	for(i=0;i<4;i++)
	{
		ADCSRA|=(1<<ADSC);
		while(ADCSRA & (1<<ADSC))
		{}
		x=x+ADCW;
	}
	ADCSRA&=~(1<<ADEN);
    x=x/5;
}
void aktualisieren(void)
{
	adw(0);
	ausgeben();
}
void temperaturberechnen(void)
{
	R=x*4.8828125*5.6/(5-x*0.0048828125);
	T=(A+sqrt(B-C*(1000-R)))/D;
}
void warte(void)
{
	unsigned char j=10;
	while(j)
	{
		_delay_ms(100);
		j--;
	}
}
int main(void)
{	
	lcd_init();
	while(1)
	{
		warte();
		lcd_clear();
		adw();
		temperaturberechnen();
		ausgeben();
	}
	return 0;

}
